{$FORM TForm2, Unit2.sfm}                                                                                                                         
 
uses
  Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, SysUtils, FuncScript, AnsiStrings, IniFiles, Registry, WinInet, UrlMon;
const 
  faAnyFile = $3F;
  faDirectory = $10;
  cRegINI = TRegIniFile.Create('HKEY_CURRENT_USER\Software\CTM\');    
  cKey = 'MONITORED\MAIN\ExchangeVersions\WH';           
var
 sr: TSearchRec;
 sPath, sProgPath, VersStsLocal, VersStsWeb, VersMonitorLocal, VersMonitorWeb : string;
 AlbumIni, StsIni, ProgVersionWeb : TIniFile;

//******************************************************************************
//      www.ctm.ru
//******************************************************************************
function GetVersionProgFromWeb(sUrl:String; sNameProgram:string): string;
var  sFileName : string;   
begin
  Result := '';                     
  try
   try
    sFileName := IncludeTrailingBackslash(ExecuteFuncScript('TempDirectory ()')) + 'PROGRAMVERSION' + ExecuteFuncScript('GENERATEUUID ()') + '.INI';
    DeleteUrlCacheEntry(sUrl);
    URLDownloadToFile(nil, sUrl, sFileName, 0, nil);
    ProgVersionWeb := TIniFile.Create(sFileName);
    Result := ProgVersionWeb.ReadString(sNameProgram, 'Version', '');     
   except
    Result := '';                     
   end;
  finally
   ProgVersionWeb.Free();
  end;
end;       

//******************************************************************************
//    
//******************************************************************************
function GetVersionProgLocal(sNameProgram:string): string;
var sScript:String;
begin
  Result := '';                     
  try
   sScript := 
    'CONST ("CSIDL_PROGRAM_FILES_COMMON", Integer, 43);'+
    'CONST ("CSIDL_PROGRAM_FILES_COMMONX86", Integer, 44);'+
    'VAR ("sCtmcfgPath",  String, "");'+
    'IF (FileExists (IncludeTrailingBackslash (SpecialFolderPath (CSIDL_PROGRAM_FILES_COMMON)) + "CTM\ctm.cfg"),'+
    '   sCtmcfgPath := IncludeTrailingBackslash (SpecialFolderPath (CSIDL_PROGRAM_FILES_COMMON)) + "CTM\ctm.cfg",'+
    ' IF (FileExists (IncludeTrailingBackslash (SpecialFolderPath (CSIDL_PROGRAM_FILES_COMMONX86)) + "CTM\ctm.cfg"),'+
    '   sCtmcfgPath := IncludeTrailingBackslash (SpecialFolderPath (CSIDL_PROGRAM_FILES_COMMONX86)) + "CTM\ctm.cfg",'+
    '   sCtmcfgPath := ""),);'+
    ' IF (INIFILE ("'+sNameProgram+'", "InstallPath", "", sCtmcfgPath) <> "",'+
    '    INIFILE ("'+sNameProgram+'", "Version", "", IncludeTrailingBackslash (INIFILE ("'+sNameProgram+'", "InstallPath", "", sCtmcfgPath)) + "SETUP.INI"),)';
    Result := ExecuteFuncScript(sScript);  
   except
    Result := '';                     
   end;
end;       

//******************************************************************************
//     
//****************************************************************************** 
procedure SetVersProgram;  
begin
  VersMonitorLocal := GetVersionProgLocal('MONITOR_ED');     
  VersMonitorWeb := GetVersionProgFromWeb('http://files.ctm.ru/MONITOR_ED/DISTR/setup.ini', 'MONITOR_ED');
  VersStsLocal := GetVersionProgLocal('STS');
  VersStsWeb := GetVersionProgFromWeb('http://files.ctm.ru/STS/DISTR/setup.ini', 'STS');
  lbVersMonitor.Caption := '';
  lbVersSts.Caption := '';
  if VersMonitorLocal <> '' then lbVersMonitor.Caption := '( ' + VersMonitorLocal + ')';
  if (VersMonitorWeb <> '') and (StrToInt(ReplaceStr(VersMonitorLocal, '.', '')) < StrToInt(ReplaceStr(VersMonitorWeb, '.', ''))) then 
     lbVersMonitor.Caption := lbVersMonitor.Caption + '->( ' + VersMonitorWeb + ')';
  if VersStsLocal <> '' then lbVersSts.Caption := '( ' + VersStsLocal + ')';
  if (VersStsWeb <> '') and (StrToInt(ReplaceStr(VersStsLocal, '.', '')) < StrToInt(ReplaceStr(VersStsWeb, '.', ''))) then        
     lbVersSts.Caption := lbVersSts.Caption + '->( ' + VersStsWeb + ')';
  
end;

//******************************************************************************
//   
//******************************************************************************
procedure CheckVersStsMon;
begin
 if cbAlbumSts.Text <> cbAlbumMon.Text then 
  begin
   lbChekVers.Caption := '  !';     
   lbChekVers.Font.Color := clRed;
   btnSaveSetting.Enabled := false;  
  end
 else
  begin                                                  
   lbChekVers.Caption := '';     
   lbChekVers.Font.Color := clRed;
   btnSaveSetting.Enabled := true;
  end
  edAlbumReestr.Text := AlbumIni.ReadString('Album_' + VarToStr( cbAlbumMon.ItemIndex), 'VersOrig', '');
  edSpec.Text := AlbumIni.ReadString('Album_' + VarToStr( cbAlbumMon.ItemIndex), 'Specification', '');
  edDateFromOfficial.Text := AlbumIni.ReadString('Album_' + VarToStr( cbAlbumMon.ItemIndex), 'DateFromOfficial', '');
  edDateFromRecommended.Text := AlbumIni.ReadString('Album_' + VarToStr( cbAlbumMon.ItemIndex), 'DateFromRecommended', '');
end;

procedure btnCancelClick(Sender: TObject);
begin
  cRegIni.Free;  
  AlbumIni.Free;
  StsIni.Free;
end;

//******************************************************************************
//  ( )   sts.ini( )   
//******************************************************************************
procedure btnSaveSettingClick(Sender: TObject);
begin      
  StsIni.WriteString('XMLFormat', 'Version', cbAlbumSts.Text);
  ExecuteFuncScript ('RegistryWriteString ("HKEY_CURRENT_USER", "Software\\CTM\\MONITORED\\MAIN\\ExchangeVersions\\WH", "FmtVersion", "'+ edAlbumReestr.Text +'")');
  ExecuteFuncScript ('RegistryWriteString ("HKEY_CURRENT_USER", "Software\\CTM\\MONITORED\\MAIN\\ExchangeVersions\\WH", "SpecVersion", "'+ edSpec.Text +'")');
//  cRegIni.WriteString(cKey, 'FmtVersion', edAlbumReestr.Text);                                                                           
//  cRegIni.WriteString(cKey, 'SpecVersion', edSpec.Text);
  btnSaveSetting.Enabled := false; 
end;

//******************************************************************************
//        
//******************************************************************************
procedure Form2Activate(Sender: TObject); 
var iIndexSerch, iCount, iTotalCount:Integer; 
    sAlbumSts, sAlbumMon, sAlbumMonOrig:String;
begin
 SetVersProgram();
 lbChekVers.Caption := '';
 sProgPath := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
 AlbumIni := TIniFile.Create(sProgPath + 'procdocs\check_album\AlbumsMonitor.ini');         
 StsIni := TIniFile.Create(sProgPath + 'sts.ini');
 ExecuteFuncScriptFromFile(sProgPath + 'procdocs\check_album\CreatListAlbumsMonitor.prd');
 sPath := ExecuteFuncScript ('PROGRAMPATH() + "Data\Impex\SCRIPTS\"');
 if FindFirst(sPath + '*.*', faAnyFile, sr) = 0 then
  begin          
    repeat
    if (sr.Attr and faDirectory) <> 0 then  //    - 
      begin
      if (sr.Name <> '.') and (sr.Name <> '..') then  //   
        begin
         cbAlbumSts.Items.Add(sr.Name);
        end;
      end;
    until FindNext(sr) <> 0;
  end;                                 
 FindClose(sr);             
 sAlbumSts := ExecuteFuncScript ('INIFILE ("XMLFormat", "Version", "5.22.0")');
 sAlbumMon := ExecuteFuncScript ('EXTRACTSTR (REGISTRYREADSTRING("HKEY_CURRENT_USER", "Software\CTM\MONITORED\MAIN\ExchangeVersions\WH", "FmtVersion", ""), 1, ".") + "." + EXTRACTSTR (REGISTRYREADSTRING("HKEY_CURRENT_USER", "Software\CTM\MONITORED\MAIN\ExchangeVersions\WH", "FmtVersion", ""), 2, ".") + "." + EXTRACTSTR (REGISTRYREADSTRING("HKEY_CURRENT_USER", "Software\CTM\MONITORED\MAIN\ExchangeVersions\WH", "FmtVersion", ""), 3, ".")');
 sAlbumMonOrig := ExecuteFuncScript ('REGISTRYREADSTRING("HKEY_CURRENT_USER", "Software\CTM\MONITORED\MAIN\ExchangeVersions\WH", "FmtVersion", "")');
 cbAlbumSts.ItemIndex := cbAlbumSts.Items.IndexOf(sAlbumSts);                                                                                       
 if StrToInt (AlbumIni.ReadString('Album', 'Count', '0')) > 0 then 
  begin                
   iTotalCount := StrToInt (AlbumIni.ReadString('Album', 'Count', '0')) - 1;
   for iCount := 0 to iTotalCount do
    begin                                                            
      cbAlbumMon.Items.Add(AlbumIni.ReadString('Album_' + VarToStr(iCount), 'Vers', '0'));  
    end;
   iIndexSerch := 0; 
//   procdocs\check_album\AlbumsMonitor.ini    ,      
   While Trim(AlbumIni.ReadString('Album_' + VarToStr(iIndexSerch), 'VersOrig', '')) <>  sAlbumMonOrig do
    iIndexSerch := iIndexSerch + 1;
   cbAlbumMon.ItemIndex := iIndexSerch;       
  end;
  CheckVersStsMon();
end;

//******************************************************************************
//         
//******************************************************************************
procedure cbAlbumStsSelect(Sender: TObject);
begin
 CheckVersStsMon();
end;

//******************************************************************************
//         
//******************************************************************************
procedure cbAlbumMonSelect(Sender: TObject);
begin
 edAlbumReestr.Text := AlbumIni.ReadString('Album_' + VarToStr( cbAlbumMon.ItemIndex), 'VersOrig', '');
 CheckVersStsMon();                           
end;

//******************************************************************************
//    .      
//******************************************************************************
procedure btnAutoSettingsClick(Sender: TObject);
var sSts, sMon:string;
    i, iIndexList,iIndexSts, iIndexMon, iFlag:Integer;
    dDateFromRecommended: DateTime;
begin
//   sMon := cbAlbumMon.Text;
   iIndexList := 0;
   iFlag :=0;
   dDateFromRecommended := StrToDate( Trim(AlbumIni.ReadString('Album_' + VarToStr(iIndexList), 'DateFromRecommended', '')));
   while (iFlag =0) do 
    begin
     sMon := cbAlbumMon.Items.Strings[iIndexList];                                           
     if Date() > dDateFromRecommended then iFlag :=1;
     cbAlbumMon.ItemIndex := iIndexList;
     CheckVersStsMon(); 
     dDateFromRecommended := StrToDate( Trim(AlbumIni.ReadString('Album_' + VarToStr(iIndexList), 'DateFromRecommended', '')));   
     iIndexList := iIndexList + 1;
    end;
   iIndexMon := cbAlbumMon.ItemIndex;
   sSts := cbAlbumSts.Text;
   iIndexMon := cbAlbumSts.ItemIndex;
   if sMon <> sSts then
    begin
     for i:=0 to cbAlbumSts.Items.Count-1 do
      begin
       if sMon = cbAlbumSts.Items.Strings[i] then 
        begin
           cbAlbumSts.ItemIndex := cbAlbumSts.Items.IndexOf(cbAlbumSts.Items.Strings[i]);
           CheckVersStsMon();
           break;
        end;
      end                          
    end;
end;

begin
end;                        
